MIMS.Portal/ViewModels/AssignDeviceViewModel.cs
using MIMS.Portal.ValueObjects.Enum;
using MIMS.Portal.ViewModels.Terminal;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using UoN.ExpressiveAnnotations.NetCore.Attributes;

namespace MIMS.Portal.ViewModels
{
    public class AssignDeviceViewModel
    {
        public TerminalViewModel? TerminalDetails { get; set; }

        [Required(ErrorMessage = "الزامی")]
        public Guid TerminalId { get; set; }

        [Display(Name = "نوع دستگاه", Prompt = "", Description = "نوع دستگاه بر حسب اتصال")]
        [Required(ErrorMessage = "الزامی")]
        public PosConnectionType DeviceConnectionType { set; get; }

        [Display(Name = "برند دستگاه", Prompt = "", Description = "")]
        [Required(ErrorMessage = "الزامی")]
        public Guid? DeviceBrandId { set; get; }

        [Display(Name = "مدل دستگاه", Prompt = "", Description = "")]
        [Required(ErrorMessage = "الزامی")]
        public Guid? DeviceModelId { set; get; }

        [Display(Name = "سریال دستگاه", Prompt = "", Description = "")]
        [Required(ErrorMessage = "الزامی")]
        public Guid? DeviceId { set; get; }       
    }
}

MIMS.Portal/ViewModels/Terminal/ShaparakViewModel.cs
using MIMS.Portal.ValueObjects.Enum;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using UoN.ExpressiveAnnotations.NetCore.Attributes;

namespace MIMS.Portal.ViewModels.Terminal
{
    public class ShaparakViewModel
    {
        [Required(ErrorMessage = "الزامی")]
        public Guid TerminalId { get; set; }

        [Display(Name = "وضعیت شاپرک")]
        [Required(ErrorMessage = "الزامی")]
        public ShaparakStatus ShaparakStatus { set; get; }

        [Display(Name = "شماره پذیرنده", Prompt = "123456", Description = "صرفا عدد")]
        [RegularExpression(@"^\d{3,}$", ErrorMessage = "نامعتبر")]
        [RequiredIf("ShaparakStatus == 5", ErrorMessage = "الزامی")]
        public string MerchantNumber { set; get; }

        [Display(Name = "شماره پایانه", Prompt = "123456", Description = "صرفا عدد")]
        [RegularExpression(@"^\d{3,}$", ErrorMessage = "نامعتبر")]
        [RequiredIf("ShaparakStatus == 5", ErrorMessage = "الزامی")]
        public string TerminalNumber { set; get; }

        [Display(Name = "توضیحات", Prompt = "توضیحات بررسی", Description = "درج توضیحات بررسی در صورت نیاز")]
        [RequiredIf("ShaparakStatus != 5", ErrorMessage = "الزامی")]
        public string ReviewComment { set; get; }
    }
}

MIMS.Portal/Controllers/OperationsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using MIMS.Portal.Commons.Extensions;
using MIMS.Portal.Core.Biz.IServices;
using MIMS.Portal.Service;
using MIMS.Portal.ValueObjects.Enum;
using MIMS.Portal.ViewModels;
using MIMS.Portal.ViewModels.Terminal;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace MIMS.Portal.Controllers
{
    [Authorize(AuthenticationSchemes = "Bearer")]

    public class OperationsController : Controller
    {
        IMerchantService _merchantService;
        IBankAccountService _bankAccountService;
        IStoreService _storeService;
        ITerminalService _terminalService;
        IDeviceService _deviceService;
        IPosBrandService _posBrandService;

        public OperationsController(ITerminalService terminalService, IMerchantService merchantService, IBankAccountService bankAccountService, IStoreService storeService, IDeviceService deviceService, IPosBrandService posBrandService)
        {
            _terminalService = terminalService;
            _merchantService = merchantService;
            _bankAccountService = bankAccountService;
            _storeService = storeService;
            _deviceService = deviceService;
            _posBrandService = posBrandService;
        }

        public IActionResult Index(string id)
        {
            if (string.IsNullOrWhiteSpace(id))
                return BadRequest();

            var status = id;

            if (!Enum.TryParse(status.Replace("-", ""), true, out TerminalStatus terminalStatus))
                return BadRequest();

          
            var terminals = Enumerable.Empty<TerminalViewModel>();

            if (User.IsInRole("Admin"))
            {
                terminals = _terminalService.GetByTerminalStatus( terminalStatus).ToList().ConvertAll(x => (TerminalViewModel)x);
            }
            else
            {
                var x = HttpContext.User.Identity as ClaimsIdentity;
                var userId = new Guid(x.FindFirst("userId").Value);
                terminals = _terminalService.GetByUserId(userId).Where(i => i.TerminalStatus == terminalStatus).ToList().ConvertAll(x => (TerminalViewModel)x);
            }

            var actionName = string.Empty;

            switch (terminalStatus)
            {
                case TerminalStatus.Sent:
                    actionName = "Shaparak";
                    break;
                case TerminalStatus.Approved:
                    actionName = "AssignDevice";
                    break;
                case TerminalStatus.DeviceAssigned:
                    actionName = "SubmitDevice";
                    break;
                case TerminalStatus.DeviceSubmitted:
                    actionName = "InitialDevice";
                    break;
                case TerminalStatus.InitialSetup:
                    actionName = "DeliveryDevice";
                    break;
                default:
                    //
                    break;
            }

            ViewBag.ActionName = actionName;

            return View(terminals);
        }

        [HttpGet]
        public IActionResult Shaparak(Guid id)
        {
            //Action on Sent status (or AwaitingForShaparakResponse)

            if (id == Guid.Empty)
                return BadRequest();

            var terminalId = id;
            var terminal = _terminalService.FindById(terminalId);

            if (terminal == null)
                return NotFound();

            //if (terminal.TerminalStatus != TerminalStatus.Sent)
            //    return NotFound();

            var model = new ShaparakReviewViewModel();
            model.TerminalDetails = terminal;
            return RedirectToAction("details", "merchants", new { id = terminal.MerchantId });


            //return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Shaparak(ShaparakViewModel model)
        {
            var view = new ShaparakReviewViewModel();

            if (ModelState.IsValid)
            {
                var review = model;

                var terminal = _terminalService.FindById(review.TerminalId);
                view.TerminalDetails = terminal;

                terminal.ReviewComment = review.ReviewComment;

                if (review.ShaparakStatus == ShaparakStatus.Approved)
                {
                    terminal.TerminalStatus = TerminalStatus.Approved;
                    terminal.MerchantNumber = review.MerchantNumber;
                    terminal.TerminalNumber = review.TerminalNumber;
                }

                if (review.ShaparakStatus == ShaparakStatus.RejectedByWhois)
                {
                    terminal.TerminalStatus = TerminalStatus.RejectedByWhois;

                    var merchant = _merchantService.GetById(terminal.MerchantId);
                    merchant.Status = ReviewStatus.Rejected;
                    merchant.ReviewComment = review.ReviewComment;

                    _merchantService.Edit(merchant);
                }

                if (review.ShaparakStatus == ShaparakStatus.RejectedByBankAccount)
                {
                    terminal.TerminalStatus = TerminalStatus.RejectedByBankAccount;

                    var bankAccount = _bankAccountService.GetById(terminal.AccountNumberId);
                    bankAccount.Status = ReviewStatus.Rejected;
                    bankAccount.ReviewComment = review.ReviewComment;

                    _bankAccountService.Edit(bankAccount);
                }

                if (review.ShaparakStatus == ShaparakStatus.RejectedByStore)
                {
                    terminal.TerminalStatus = TerminalStatus.RejectedByStore;

                    var store = _storeService.GetById(terminal.StoreId);
                    store.Status = ReviewStatus.Rejected;
                    store.ReviewComment = review.ReviewComment;

                    _storeService.Edit(store);
                }

                if (review.ShaparakStatus == ShaparakStatus.RejectedByOther)
                {
                    terminal.TerminalStatus = TerminalStatus.RejectedByOther;

                    var merchant = _merchantService.GetById(terminal.MerchantId);
                    merchant.Status = ReviewStatus.Rejected;
                    merchant.ReviewComment = review.ReviewComment;

                    _merchantService.Edit(merchant);

                    var bankAccount = _bankAccountService.GetById(terminal.AccountNumberId);
                    bankAccount.Status = ReviewStatus.Rejected;
                    bankAccount.ReviewComment = review.ReviewComment;

                    _bankAccountService.Edit(bankAccount);

                    var store = _storeService.GetById(terminal.StoreId);
                    store.Status = ReviewStatus.Rejected;
                    store.ReviewComment = review.ReviewComment;

                    _storeService.Edit(store);
                }

                _terminalService.Edit(terminal);

                var toastr = new Toastr
                {
                    Type = ToastrType.Success,
                    Subject = "تعیین وضعیت",
                    Content = "اطلاعات با موفقیت ثبت شد"
                };
                Toastrs.ToastrsList.Add(toastr);

                return RedirectToAction(nameof(Index), new { id = TerminalStatus.Sent });
            }

            return View(view);
        }

        [HttpGet]
        public IActionResult AssignDevice(Guid id)
        {
            if (id == Guid.Empty)
                return BadRequest();

            var terminalId = id;
            var terminal = _terminalService.FindById(terminalId);

            if (terminal == null)
                return NotFound();

            if (terminal.TerminalStatus != TerminalStatus.Approved)
                return NotFound();

            var model = new AssignDeviceViewModel();
            model.TerminalDetails = terminal;
            model.DeviceConnectionType = terminal.ConnectionType;

            ViewBag.DeviceBrands = new SelectList(_posBrandService.FindParents(), "Id", "Name");

            return View(model);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult AssignDevice(AssignDeviceViewModel model)
        {

            if (ModelState.IsValid)
            {
                var terminal = _terminalService.FindById(model.TerminalId);

                terminal.TerminalStatus = TerminalStatus.DeviceAssigned;
                terminal.PosDeviceBrandId = model.DeviceBrandId;
                terminal.PosDeviceModelId = model.DeviceModelId;
                terminal.PosDeviceId = model.DeviceId;
                _terminalService.Edit(terminal);

                var device = _deviceService.FindById(model.DeviceId.GetValueOrDefault());
                device.DeviceStatus = PosStatus.TerminalAssigned;
                _deviceService.Update(device);

                var toastr = new Toastr
                {
                    Type = ToastrType.Success,
                    Subject = "تخصیص دستگاه",
                    Content = "اطلاعات با موفقیت ثبت شد"
                };
                Toastrs.ToastrsList.Add(toastr);

                //return RedirectToAction(nameof(Index), new { id = TerminalStatus.Approved });
                return RedirectToAction("details", "merchants", new { id = terminal.MerchantId });

            }


            return View(model);
        }


        public IActionResult SubmitDevice(Guid id)
        {
            if (id == Guid.Empty)
                return BadRequest();

            var terminalId = id;
            var terminal = _terminalService.FindById(terminalId);

            if (terminal == null)
                return NotFound();

            if (terminal.TerminalStatus != TerminalStatus.DeviceAssigned)

MIMS.Portal/Views/Operations/AssignDevice.cshtml
@model MIMS.Portal.ViewModels.AssignDeviceViewModel
@using MIMS.Portal.Core.Domains;

@{
    ViewData["PageTitle"] = "تخصیص دستگاه";
}

<section>
    <form method="post" enctype="multipart/form-data">
        <div class="card">
            <div class="card-header">
                <h4 class="card-title">مشخصات پایانه</h4>
            </div>
            <div class="card-body">
                <div class="card-block">
                    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                    <input asp-for="TerminalId" value="@Model.TerminalDetails.Id" hidden />
                    <div class="form">
                        <div class="form-body">
                            <div class="row">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.MerchantFullName" class="control-label"></label>
                                        <p><strong>@Model.TerminalDetails?.MerchantFullName</strong></p>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.MerchantNationalCode" class="control-label"></label>
                                        <p><strong>@Model.TerminalDetails?.MerchantNationalCode</strong></p>
                                    </div>
                                </div>
                            </div>
                            <hr />
                            <div class="row">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.TerminalType" class="control-label"></label>
                                        <p><strong>@Html.DisplayFor(model => model.TerminalDetails.TerminalType)</strong></p>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.PspProvider" class="control-label"></label>
                                        <p><strong>@Html.DisplayFor(model => model.TerminalDetails.PspProvider)</strong></p>

                                    </div>
                                </div>
                            </div>
                            <hr />
                            <div class="row">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.StoreId" class="control-label"></label>
                                        <p><strong>@Model.TerminalDetails?.StoreFullName</strong></p>

                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label asp-for="TerminalDetails.BankAccountId" class="control-label"></label>
                                        <p><strong>@Model.TerminalDetails?.BankAccountFullName</strong></p>

                                    </div>
                                </div>

                            </div>
                            <hr />
                            <div class="row">
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="DeviceConnectionType" class="control-label"></label>
                                        <span asp-validation-for="DeviceConnectionType" class="text-danger"></span>
                                        <p><strong>@Html.DisplayFor(model => model.TerminalDetails.DeviceConnectionType)</strong></p>
                                        <input asp-for="DeviceConnectionType" hidden />
                                        @*<select asp-for="DeviceConnectionType" asp-description-for="DeviceConnectionType" class="form-control" asp-items="@Html.GetEnumSelectList<MIMS.Portal.ValueObjects.Enum.PosConnectionType>()">
                                            <option selected value="">--</option>
                                        </select>*@
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="DeviceBrandId" class="control-label"></label>
                                        <span asp-validation-for="DeviceBrandId" class="text-danger"></span>
                                        <select asp-for="DeviceBrandId" asp-description-for="DeviceBrandId" class="form-control" asp-items="@ViewBag.DeviceBrands">
                                            <option selected value="">--</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="DeviceModelId" class="control-label"></label>
                                        <span asp-validation-for="DeviceModelId" class="text-danger"></span>
                                        <select asp-for="DeviceModelId" asp-description-for="DeviceModelId" class="form-control" asp-items="@ViewBag.DeviceModels">
                                            <option selected value="">--</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label asp-for="DeviceId" class="control-label"></label>
                                        <span asp-validation-for="DeviceId" class="text-danger"></span>
                                        <select asp-for="DeviceId" asp-description-for="DeviceId" class="form-control" asp-items="@ViewBag.Devices">
                                            <option selected value="">--</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-footer">
                            <div class="form-actions">
                                <button type="submit" class="btn btn-primary btn-min-width">
                                    ثبت
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
</section>

@section Scripts{
    <script src="~/js/dropdown.js"></script>
}

MIMS.Portal/Views/Operations/Index.cshtml
@model IEnumerable<MIMS.Portal.ViewModels.Terminal.TerminalViewModel>
@using MIMS.Portal.Commons.Extensions;
@using MIMS.Portal.ValueObjects.Enum;


@{
    var title = "تایید";
    var icon = "check";
    var statusTitle = "";

    var id = Context.Request.RouteValues["id"]?.ToString() ?? string.Empty;

    if (!string.IsNullOrEmpty(id) && Enum.TryParse(id.Replace("-", ""), true, out TerminalStatus status))
    {
        //if (status != null)
        statusTitle = ((TerminalStatus)(((int)status) + 1)).GetDisplayName();

        if (status == TerminalStatus.PreApproved || status == TerminalStatus.Sent || status == TerminalStatus.Approved)
        {
            title = "جزئیات";
            icon = "eye";
        }
    }

}
@{
    ViewData["PageTitle"] = @statusTitle;
}
<section id="operations-index">
    <div class="card">
        <div class="card-header">
            <h4 class="">فهرست</h4>
        </div>
        <div class="card-body">
            <div class="card-block">
                <div class="table-responsive">
                    <table class="table table-hover header-border text-nowrap">
                        <thead class="thead-inverse">
                            <tr>
                                <th>@Html.DisplayNameFor(model => model.MerchantFullName)</th>
                                <th>@Html.DisplayNameFor(model => model.MerchantNationalCode)</th>
                                <th>@Html.DisplayNameFor(model => model.BankAccountId)</th>
                                <th>@Html.DisplayNameFor(model => model.StoreId)</th>
                                <th>@Html.DisplayNameFor(model => model.TerminalType)</th>
                                <th>@Html.DisplayNameFor(model => model.TerminalNumber)</th>
                                <th>@Html.DisplayNameFor(model => model.MerchantNumber)</th>
                                <th>@Html.DisplayNameFor(model => model.DeviceConnectionType)</th>
                                <th>@Html.DisplayNameFor(model => model.DeviceModelId)</th>
                                <th>@Html.DisplayNameFor(model => model.DeviceId)</th>
                                <th>@Html.DisplayNameFor(model => model.CreatedDate)</th>
                                <th class="no-sort"><em class="fa fa-cog"></em></th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>@item.MerchantFullName</td>
                                    <td>@item.MerchantNationalCode</td>
                                    <td>@item.BankAccountFullName</td>
                                    <td>@item.StoreFullName</td>
                                    <td>@Html.DisplayFor(modelItem => item.TerminalType)</td>
                                    <td>@item.TerminalNumber</td>
                                    <td>@item.MerchantNumber</td>
                                    <td>@Html.DisplayFor(modelItem => item.DeviceConnectionType)</td>
                                    <td>@($"{item.DeviceBrandName} {item.DeviceModelName}")</td>
                                    <td>@item.DeviceSerial</td>
                                    <td><span dir="ltr">@item.CreatedDate.ToPeString()</span></td>
                                    <td>
                                        <a asp-action="@ViewBag.ActionName" asp-controller="Operations" asp-route-id="@item.Id" class="btn btn-secondary fa fa-fw fa-@icon" data-toggle="tooltip" title="@title"></a>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                </div>

            </div>
        </div>
        <div class="card-footer">
            <small>
                آخرین بروز رسانی لحظاتی پیش
            </small>
        </div>
    </div>
</section>